library model;
import 'dart:convert';

abstract class Model
{
  Model();
  Model.parse(Map<String, dynamic> data)
  {
    addedBy = data["added_by"];
    created = data["created"];
    status = data["status"];
  }

  Model.from(Model other)
  {
    addedBy = other.addedBy;
    created = other.created;
    status = other.status;
  }

  Map<String, dynamic> get properties
  {
    Map<String, dynamic> data = new Map();
    data["added_by"] = addedBy;
    data["created"] = created;
    data["status"] = status;
    return data;
  }

  String get toJSON
  {
    return JSON.encode(properties);
  }

  List<String> get uniqueFields;

  String addedBy;
  String created;
  String status = "active"; // active, frozen, disabled

}