library service;

import 'model.dart';
import 'service_addon.dart';

class Service extends Model
{
  Service()
  {
  }

  Service.parse(Map<String, dynamic> data) : super.parse(data)
  {
    category = data["category"];
    description = data["description"];
    name = data["name"];
    durationMinutes = data["duration"];
    price = data["price"];
    for (Map<String, dynamic> addon in data["addons"])
    {
      _addons.add(new ServiceAddon.parse(addon));
    }
  }

  Service.from(Service other) : super.from(other)
  {
    category = other.category;
    description = other.description;
    name = other.name;
    durationMinutes = other.durationMinutes;
    price = other.price;
    _addons = new List.from(other._addons);
  }

  @override
  Map<String, dynamic> get properties
  {
    Map<String, dynamic> data = super.properties;
    data["category"] = category;
    data["description"] = description;
    data["name"] = name;
    data["duration"] = durationMinutes;
    data["price"] = price;
    data["addons"] = new List<Map<String, dynamic>>();

    for (ServiceAddon addon in _addons)
    {
      data["addons"].add(addon.properties);
    }
    return data;
  }

  List<ServiceAddon> get addons => _addons;

  @override
  List<String> get uniqueFields => [];

  List<ServiceAddon> _addons = new List();
  String category;
  String description;
  String name;
  int durationMinutes;
  double price;
}