library user;

import 'model.dart';
import 'package:angular2/common.dart';
import 'package:fo_components/fo_components.dart';


class User extends Model
{
  User();

  @override
  User.parse(Map<String, dynamic> data) : super.parse(data)
  {
    city = data["city"];
    country = data["country"];
    email = data["email"];
    firstname = data["firstname"];
    lastname = data["lastname"];
    phone = data["phone"];
    postalCode = data["postal_code"];
    socialNumber = data["social_number"];
    street = data["street"];
  }

  @override
  Map<String, dynamic> get properties
  {
    Map<String, dynamic> data = super.properties;
    data["city"] = city;
    data["country"] = country;
    data["email"] = email;
    data["firstname"] = firstname;
    data["lastname"] = lastname;
    data["phone"] = phone;
    data["postal_code"] = postalCode;
    data["social_number"] = socialNumber;
    data["street"] = street;
    return data;
  }

  @override
  List<String> get uniqueFields => ["email", "phone", "social_number"];

  static Map<String, dynamic> get controlsConfig => _controlsConfig;

  static Map<String, dynamic> _controlsConfig =
  {
    "email":[null, Validators.compose([Validators.required, Validators.maxLength(100)])],
    "phone":[null, Validators.compose([Validators.required, FoValidators.isPhoneNumber, Validators.maxLength(32)])],
    "social_number":[null, Validators.compose([Validators.required, Validators.minLength(12), Validators.maxLength(12), FoValidators.isNumeric])],
    "firstname":[null, Validators.compose([Validators.required, FoValidators.isName, Validators.maxLength(64)])],
    "lastname":[null, Validators.compose([Validators.required, FoValidators.isName, Validators.maxLength(64)])],
    "street":[null, Validators.compose([Validators.required, Validators.minLength(4), Validators.maxLength(64)])],
    "postal_code":[null, Validators.compose([Validators.required, FoValidators.isAlphaNumeric, Validators.minLength(2), Validators.maxLength(20)])],
    "city":[null, Validators.compose([Validators.required, Validators.maxLength(64)])],
    "country" : ["sv", Validators.required],
    "status" : ["active", Validators.required],
    "password" : [null, Validators.compose([Validators.required, Validators.minLength(6), Validators.maxLength(64)])],
  };

  String city;
  String country = "sv";
  String email;
  String firstname;
  String lastname;
  String phone;
  String postalCode;
  String socialNumber;
  String street;

  String password;
}